var SpriteMap = require('primo-spritemap')
var SoundResource = require('primo-audio')
var TextureResource = require('./textureresource')

var Resources = function() {
  this.cache = {}
  this.waitingForCount = 0
}

Resources.prototype = {
  spritemap: function(path, spritewidth, spriteheight) {
    var image = this.image(path)
    return new SpriteMap(image, spritewidth, spriteheight)
  },
  image: function(path) {
    var resource = this.cache[path]
    if(!resource) {
      resource = new TextureResource(path)
      this.cache[path] = resource
      this.registerLoadingResource(resource)
    }
    return resource
  },
  sound: function(path) {
    var resource = this.cache[path]
    if(!resource) {
      resource = new SoundResource(path)
      this.cache[path] = resource
      this.registerLoadingResource(resource)
    }
    return resource
  },
  registerLoadingResource: function(resource) {
    this.waitingForCount++
    resource.once('loaded', function() {
      this.waitingForCount--
    }, this)
  }
}

module.exports = Resources

